Codeforces Round #305 (Div. 2) D.Mike and Feet

D. Mike and Feet
time limit per test
1 second
memory limit per test
256 megabytes
input
standard input
output
standard output

Mike is the president of country What-The-Fatherland. There are n bears living in this country besides Mike. All of them are standing in a line and they are numbered from 1 to n from left to right. i-th bear is exactly ai feet high.

A group of bears is a non-empty contiguous segment of the line. The size of a group is the number of bears in that group. The strength of a group is the minimum height of the bear in that group.

Mike is a curious to know for each x such that 1 ≤ x ≤ n the maximum strength among all groups of size x.

Input

The first line of input contains integer n (1 ≤ n ≤ 2 × 105), the number of bears.

The second line contains n integers separated by space, a1, a2, ..., an (1 ≤ ai ≤ 109), heights of bears.

Output

Print n integers in one line. For each x from 1 to n, print the maximum strength among all groups of size x.

Examples
input
10
1 2 3 4 5 4 3 2 1 6
output
6 4 4 3 3 2 2 1 1 1 
借鉴自:http://blog.csdn.net/libin56842/article/details/46473803

题意不说了。在紫书上有单调栈的类似题,脑洞不够大想不到O(n)做法。借鉴了大神的单调栈思路,想的还是不是很透彻。

大意是通过构造一个单调递增的栈来判断某长度的区间内最小的值为多大。

先构造node,num表示入栈时该元素的值,width表示宽度,也即是离栈顶元素的距离。找到连续区间最小值时,实际是找到最小值向左向右可扩展的最长距离。此处的width表示向左扩展的距离(包括自身),向右扩展的距离需要退栈时计算(即while循环中的len)。

处理完毕后,由于可能存在未更新的点,从后向前更新:

ans[i]=max(ans[i],ans[i+1])

此处理解不是很完全,初看以为防止ans[i]=0,后发现实际情况中不只于此,还能保证ans[i]的大小,最后还是存疑。


#include 
#include 
#include 
#include 
#include 
#include 
#include 
#include 
#include 
#include 
#include 
#include 
#include 
using namespace std;
#define INF 0x3f3f3f3
const int N=200005;
const int mod=1e9+7;

struct node{
    int num,width;
    node() {};
    node(int _num,int _width):num(_num),width(_width) {}
};

stack s;
int a[N],ans[N];

int main(){
    int n,i,j;
    cin>>n;
    for (i=0; ians[ls]) {
                ans[ls]=k.num;
            }
            len+=k.width;
            s.pop();
        }
        s.push(node(a[i],len+1));
    }
    for (i=n-1; i>=1; i--) {
        ans[i]=max(ans[i],ans[i+1]);
    }
    for (i=1; i


你可能感兴趣的:(codeforces)